// FullAccess
resource "azurerm_role_definition" "api_management_fullaccess_definition" {
  name              = "api-management-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.ApiManagement/register/action",
      "Microsoft.ApiManagement/unregister/action",
      "Microsoft.ApiManagement/service/write",
      "Microsoft.ApiManagement/service/read",
      "Microsoft.ApiManagement/service/delete",
      "Microsoft.ApiManagement/service/updatehostname/action",
      "Microsoft.ApiManagement/service/updatecertificate/action",
      "Microsoft.ApiManagement/service/backup/action",
      "Microsoft.ApiManagement/service/restore/action",
      "Microsoft.ApiManagement/service/managedeployments/action",
      "Microsoft.ApiManagement/service/getssotoken/action",
      "Microsoft.ApiManagement/service/applynetworkconfigurationupdates/action",
      "Microsoft.ApiManagement/service/users/action",
      "Microsoft.ApiManagement/service/notifications/action",
      "Microsoft.ApiManagement/service/gateways/action",
      "Microsoft.ApiManagement/service/operationresults/read",
      "Microsoft.ApiManagement/operations/read",
      "Microsoft.ApiManagement/checkNameAvailability/read",
      "Microsoft.ApiManagement/service/networkstatus/read",
      "Microsoft.ApiManagement/service/locations/networkstatus/read",
      "Microsoft.ApiManagement/reports/read",
      "Microsoft.ApiManagement/service/tenant/read",
      "Microsoft.ApiManagement/service/tenant/write",
      "Microsoft.ApiManagement/service/tenant/delete",
      "Microsoft.ApiManagement/service/tenant/regeneratePrimaryKey/action",
      "Microsoft.ApiManagement/service/tenant/regenerateSecondaryKey/action",
      "Microsoft.ApiManagement/service/tenant/deploy/action",
      "Microsoft.ApiManagement/service/tenant/save/action",
      "Microsoft.ApiManagement/service/tenant/validate/action",
      "Microsoft.ApiManagement/service/tenant/operationResults/read",
      "Microsoft.ApiManagement/service/tenant/syncState/read",
      "Microsoft.ApiManagement/service/groups/read",
      "Microsoft.ApiManagement/service/groups/write",
      "Microsoft.ApiManagement/service/groups/delete",
      "Microsoft.ApiManagement/service/groups/users/read",
      "Microsoft.ApiManagement/service/groups/users/write",
      "Microsoft.ApiManagement/service/groups/users/delete",
      "Microsoft.ApiManagement/service/users/read",
      "Microsoft.ApiManagement/service/users/write",
      "Microsoft.ApiManagement/service/users/delete",
      "Microsoft.ApiManagement/service/users/generateSsoUrl/action",
      "Microsoft.ApiManagement/service/users/token/action",
      "Microsoft.ApiManagement/service/users/groups/read",
      "Microsoft.ApiManagement/service/users/subscriptions/read",
      "Microsoft.ApiManagement/service/products/read",
      "Microsoft.ApiManagement/service/products/write",
      "Microsoft.ApiManagement/service/products/delete",
      "Microsoft.ApiManagement/service/products/apis/read",
      "Microsoft.ApiManagement/service/products/apis/write",
      "Microsoft.ApiManagement/service/products/apis/delete",
      "Microsoft.ApiManagement/service/products/subscriptions/read",
      "Microsoft.ApiManagement/service/products/policies/read",
      "Microsoft.ApiManagement/service/products/policies/write",
      "Microsoft.ApiManagement/service/products/policies/delete",
      "Microsoft.ApiManagement/service/products/groups/read",
      "Microsoft.ApiManagement/service/products/groups/write",
      "Microsoft.ApiManagement/service/products/groups/delete",
      "Microsoft.ApiManagement/service/products/tags/read",
      "Microsoft.ApiManagement/service/products/tags/write",
      "Microsoft.ApiManagement/service/products/tags/delete",
      "Microsoft.ApiManagement/service/subscriptions/read",
      "Microsoft.ApiManagement/service/subscriptions/write",
      "Microsoft.ApiManagement/service/subscriptions/delete",
      "Microsoft.ApiManagement/service/subscriptions/regeneratePrimaryKey/action",
      "Microsoft.ApiManagement/service/subscriptions/regenerateSecondaryKey/action",
      "Microsoft.ApiManagement/service/apis/read",
      "Microsoft.ApiManagement/service/apis/write",
      "Microsoft.ApiManagement/service/apis/delete",
      "Microsoft.ApiManagement/service/apis/operations/read",
      "Microsoft.ApiManagement/service/apis/operations/write",
      "Microsoft.ApiManagement/service/apis/operations/delete",
      "Microsoft.ApiManagement/service/apis/operations/policies/read",
      "Microsoft.ApiManagement/service/apis/operations/policies/write",
      "Microsoft.ApiManagement/service/apis/operations/policies/delete",
      "Microsoft.ApiManagement/service/apis/operations/tags/read",
      "Microsoft.ApiManagement/service/apis/operations/tags/write",
      "Microsoft.ApiManagement/service/apis/operations/tags/delete",
      "Microsoft.ApiManagement/service/apis/revisions/read",
      "Microsoft.ApiManagement/service/apis/revisions/delete",
      "Microsoft.ApiManagement/service/apis/releases/read",
      "Microsoft.ApiManagement/service/apis/releases/delete",
      "Microsoft.ApiManagement/service/apis/releases/write",
      "Microsoft.ApiManagement/service/apis/policies/read",
      "Microsoft.ApiManagement/service/apis/policies/write",
      "Microsoft.ApiManagement/service/apis/policies/delete",
      "Microsoft.ApiManagement/service/apis/products/read",
      "Microsoft.ApiManagement/service/apis/schemas/read",
      "Microsoft.ApiManagement/service/apis/schemas/write",
      "Microsoft.ApiManagement/service/apis/schemas/delete",
      "Microsoft.ApiManagement/service/apis/issues/read",
      "Microsoft.ApiManagement/service/apis/issues/write",
      "Microsoft.ApiManagement/service/apis/issues/delete",
      "Microsoft.ApiManagement/service/apis/issues/attachments/read",
      "Microsoft.ApiManagement/service/apis/issues/attachments/write",
      "Microsoft.ApiManagement/service/apis/issues/attachments/delete",
      "Microsoft.ApiManagement/service/apis/issues/comments/read",
      "Microsoft.ApiManagement/service/apis/issues/comments/write",
      "Microsoft.ApiManagement/service/apis/issues/comments/delete",
      "Microsoft.ApiManagement/service/apis/tagDescriptions/read",
      "Microsoft.ApiManagement/service/apis/tagDescriptions/write",
      "Microsoft.ApiManagement/service/apis/tagDescriptions/delete",
      "Microsoft.ApiManagement/service/apis/tags/read",
      "Microsoft.ApiManagement/service/apis/tags/write",
      "Microsoft.ApiManagement/service/apis/tags/delete",
      "Microsoft.ApiManagement/service/apis/operationsByTags/read",
      "Microsoft.ApiManagement/service/apis/diagnostics/read",
      "Microsoft.ApiManagement/service/apis/diagnostics/write",
      "Microsoft.ApiManagement/service/apis/diagnostics/delete",
      "Microsoft.ApiManagement/service/policies/read",
      "Microsoft.ApiManagement/service/policies/write",
      "Microsoft.ApiManagement/service/policies/delete",
      "Microsoft.ApiManagement/service/reports/read",
      "Microsoft.ApiManagement/service/policySnippets/read",
      "Microsoft.ApiManagement/service/certificates/read",
      "Microsoft.ApiManagement/service/certificates/write",
      "Microsoft.ApiManagement/service/certificates/delete",
      "Microsoft.ApiManagement/service/loggers/read",
      "Microsoft.ApiManagement/service/loggers/write",
      "Microsoft.ApiManagement/service/loggers/delete",
      "Microsoft.ApiManagement/service/authorizationServers/read",
      "Microsoft.ApiManagement/service/authorizationServers/write",
      "Microsoft.ApiManagement/service/authorizationServers/delete",
      "Microsoft.ApiManagement/service/backends/read",
      "Microsoft.ApiManagement/service/backends/write",
      "Microsoft.ApiManagement/service/backends/delete",
      "Microsoft.ApiManagement/service/backends/reconnect/action",
      "Microsoft.ApiManagement/service/templates/read",
      "Microsoft.ApiManagement/service/templates/write",
      "Microsoft.ApiManagement/service/templates/delete",
      "Microsoft.ApiManagement/service/properties/read",
      "Microsoft.ApiManagement/service/properties/write",
      "Microsoft.ApiManagement/service/properties/delete",
      "Microsoft.ApiManagement/service/notifications/read",
      "Microsoft.ApiManagement/service/notifications/write",
      "Microsoft.ApiManagement/service/notifications/recipientEmails/read",
      "Microsoft.ApiManagement/service/notifications/recipientEmails/write",
      "Microsoft.ApiManagement/service/notifications/recipientEmails/delete",
      "Microsoft.ApiManagement/service/notifications/recipientUsers/read",
      "Microsoft.ApiManagement/service/notifications/recipientUsers/write",
      "Microsoft.ApiManagement/service/notifications/recipientUsers/delete",
      "Microsoft.ApiManagement/service/openidConnectProviders/read",
      "Microsoft.ApiManagement/service/openidConnectProviders/write",
      "Microsoft.ApiManagement/service/openidConnectProviders/delete",
      "Microsoft.ApiManagement/service/quotas/read",
      "Microsoft.ApiManagement/service/quotas/write",
      "Microsoft.ApiManagement/service/quotas/periods/read",
      "Microsoft.ApiManagement/service/quotas/periods/write",
      "Microsoft.ApiManagement/service/identityProviders/read",
      "Microsoft.ApiManagement/service/identityProviders/write",
      "Microsoft.ApiManagement/service/identityProviders/delete",
      "Microsoft.ApiManagement/service/portalsettings/read",
      "Microsoft.ApiManagement/service/portalsettings/write",
      "Microsoft.ApiManagement/service/diagnostics/read",
      "Microsoft.ApiManagement/service/diagnostics/write",
      "Microsoft.ApiManagement/service/diagnostics/delete",
      "Microsoft.ApiManagement/service/tags/read",
      "Microsoft.ApiManagement/service/tags/write",
      "Microsoft.ApiManagement/service/tags/delete",
      "Microsoft.ApiManagement/service/tagResources/read",
      "Microsoft.ApiManagement/service/apisByTags/read",
      "Microsoft.ApiManagement/service/productsByTags/read",
      "Microsoft.ApiManagement/service/users/confirmations/send/action",
      "Microsoft.ApiManagement/service/apiVersionSets/read",
      "Microsoft.ApiManagement/service/apiVersionSets/write",
      "Microsoft.ApiManagement/service/apiVersionSets/delete",
      "Microsoft.ApiManagement/service/apiVersionSets/versions/read",
      "Microsoft.ApiManagement/service/contentTypes/read",
      "Microsoft.ApiManagement/service/contentTypes/contentItems/read",
      "Microsoft.ApiManagement/service/contentTypes/contentItems/write",
      "Microsoft.ApiManagement/service/contentTypes/contentItems/delete",
      "Microsoft.ApiManagement/service/users/identities/read",
      "Microsoft.ApiManagement/service/regions/read",
      "Microsoft.ApiManagement/service/issues/read",
      "Microsoft.ApiManagement/service/caches/read",
      "Microsoft.ApiManagement/service/caches/write",
      "Microsoft.ApiManagement/service/caches/delete",
      "Microsoft.ApiManagement/service/users/keys/read",
      "Microsoft.ApiManagement/service/policy/read",
      "Microsoft.ApiManagement/service/policy/write",
      "Microsoft.ApiManagement/service/policy/delete",
      "Microsoft.ApiManagement/service/apis/policy/read",
      "Microsoft.ApiManagement/service/apis/policy/write",
      "Microsoft.ApiManagement/service/apis/policy/delete",
      "Microsoft.ApiManagement/service/apis/operations/policy/read",
      "Microsoft.ApiManagement/service/apis/operations/policy/write",
      "Microsoft.ApiManagement/service/apis/operations/policy/delete",
      "Microsoft.ApiManagement/service/products/policy/read",
      "Microsoft.ApiManagement/service/products/policy/write",
      "Microsoft.ApiManagement/service/products/policy/delete",
      "Microsoft.ApiManagement/service/gateways/read",
      "Microsoft.ApiManagement/service/gateways/write",
      "Microsoft.ApiManagement/service/gateways/delete",
      "Microsoft.ApiManagement/service/gateways/keys/action",
      "Microsoft.ApiManagement/service/gateways/regeneratePrimaryKey/action",
      "Microsoft.ApiManagement/service/gateways/regenerateSecondaryKey/action",
      "Microsoft.ApiManagement/service/gateways/token/action",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "api_management_readonly_definition" {
  name              = "api-management-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.ApiManagement/service/read",
      "Microsoft.ApiManagement/service/operationresults/read",
      "Microsoft.ApiManagement/operations/read",
      "Microsoft.ApiManagement/checkNameAvailability/read",
      "Microsoft.ApiManagement/service/networkstatus/read",
      "Microsoft.ApiManagement/service/locations/networkstatus/read",
      "Microsoft.ApiManagement/reports/read",
      "Microsoft.ApiManagement/service/tenant/read",
      "Microsoft.ApiManagement/service/tenant/operationResults/read",
      "Microsoft.ApiManagement/service/tenant/syncState/read",
      "Microsoft.ApiManagement/service/groups/read",
      "Microsoft.ApiManagement/service/groups/users/read",
      "Microsoft.ApiManagement/service/users/read",
      "Microsoft.ApiManagement/service/users/groups/read",
      "Microsoft.ApiManagement/service/users/subscriptions/read",
      "Microsoft.ApiManagement/service/products/read",
      "Microsoft.ApiManagement/service/products/apis/read",
      "Microsoft.ApiManagement/service/products/subscriptions/read",
      "Microsoft.ApiManagement/service/products/policies/read",
      "Microsoft.ApiManagement/service/products/groups/read",
      "Microsoft.ApiManagement/service/products/tags/read",
      "Microsoft.ApiManagement/service/subscriptions/read",
      "Microsoft.ApiManagement/service/apis/read",
      "Microsoft.ApiManagement/service/apis/operations/read",
      "Microsoft.ApiManagement/service/apis/operations/policies/read",
      "Microsoft.ApiManagement/service/apis/operations/tags/read",
      "Microsoft.ApiManagement/service/apis/revisions/read",
      "Microsoft.ApiManagement/service/apis/releases/read",
      "Microsoft.ApiManagement/service/apis/policies/read",
      "Microsoft.ApiManagement/service/apis/products/read",
      "Microsoft.ApiManagement/service/apis/schemas/read",
      "Microsoft.ApiManagement/service/apis/issues/read",
      "Microsoft.ApiManagement/service/apis/issues/attachments/read",
      "Microsoft.ApiManagement/service/apis/issues/comments/read",
      "Microsoft.ApiManagement/service/apis/tagDescriptions/read",
      "Microsoft.ApiManagement/service/apis/tags/read",
      "Microsoft.ApiManagement/service/apis/operationsByTags/read",
      "Microsoft.ApiManagement/service/apis/diagnostics/read",
      "Microsoft.ApiManagement/service/policies/read",
      "Microsoft.ApiManagement/service/reports/read",
      "Microsoft.ApiManagement/service/policySnippets/read",
      "Microsoft.ApiManagement/service/certificates/read",
      "Microsoft.ApiManagement/service/loggers/read",
      "Microsoft.ApiManagement/service/authorizationServers/read",
      "Microsoft.ApiManagement/service/backends/read",
      "Microsoft.ApiManagement/service/templates/read",
      "Microsoft.ApiManagement/service/properties/read",
      "Microsoft.ApiManagement/service/notifications/read",
      "Microsoft.ApiManagement/service/notifications/recipientEmails/read",
      "Microsoft.ApiManagement/service/notifications/recipientUsers/read",
      "Microsoft.ApiManagement/service/openidConnectProviders/read",
      "Microsoft.ApiManagement/service/quotas/read",
      "Microsoft.ApiManagement/service/quotas/periods/read",
      "Microsoft.ApiManagement/service/identityProviders/read",
      "Microsoft.ApiManagement/service/portalsettings/read",
      "Microsoft.ApiManagement/service/diagnostics/read",
      "Microsoft.ApiManagement/service/tags/read",
      "Microsoft.ApiManagement/service/tagResources/read",
      "Microsoft.ApiManagement/service/apisByTags/read",
      "Microsoft.ApiManagement/service/productsByTags/read",
      "Microsoft.ApiManagement/service/apiVersionSets/read",
      "Microsoft.ApiManagement/service/apiVersionSets/versions/read",
      "Microsoft.ApiManagement/service/contentTypes/read",
      "Microsoft.ApiManagement/service/contentTypes/contentItems/read",
      "Microsoft.ApiManagement/service/users/identities/read",
      "Microsoft.ApiManagement/service/regions/read",
      "Microsoft.ApiManagement/service/issues/read",
      "Microsoft.ApiManagement/service/caches/read",
      "Microsoft.ApiManagement/service/users/keys/read",
      "Microsoft.ApiManagement/service/policy/read",
      "Microsoft.ApiManagement/service/apis/policy/read",
      "Microsoft.ApiManagement/service/apis/operations/policy/read",
      "Microsoft.ApiManagement/service/products/policy/read",
      "Microsoft.ApiManagement/service/gateways/read",
    ]

    not_actions = [
      "Microsoft.ApiManagement/register/action",
      "Microsoft.ApiManagement/unregister/action",
      "Microsoft.ApiManagement/service/write",
      "Microsoft.ApiManagement/service/delete",
      "Microsoft.ApiManagement/service/updatehostname/action",
      "Microsoft.ApiManagement/service/updatecertificate/action",
      "Microsoft.ApiManagement/service/backup/action",
      "Microsoft.ApiManagement/service/restore/action",
      "Microsoft.ApiManagement/service/managedeployments/action",
      "Microsoft.ApiManagement/service/getssotoken/action",
      "Microsoft.ApiManagement/service/applynetworkconfigurationupdates/action",
      "Microsoft.ApiManagement/service/users/action",
      "Microsoft.ApiManagement/service/notifications/action",
      "Microsoft.ApiManagement/service/gateways/action",
      "Microsoft.ApiManagement/service/tenant/write",
      "Microsoft.ApiManagement/service/tenant/delete",
      "Microsoft.ApiManagement/service/tenant/regeneratePrimaryKey/action",
      "Microsoft.ApiManagement/service/tenant/regenerateSecondaryKey/action",
      "Microsoft.ApiManagement/service/tenant/deploy/action",
      "Microsoft.ApiManagement/service/tenant/save/action",
      "Microsoft.ApiManagement/service/tenant/validate/action",
      "Microsoft.ApiManagement/service/groups/write",
      "Microsoft.ApiManagement/service/groups/delete",
      "Microsoft.ApiManagement/service/groups/users/write",
      "Microsoft.ApiManagement/service/groups/users/delete",
      "Microsoft.ApiManagement/service/users/write",
      "Microsoft.ApiManagement/service/users/delete",
      "Microsoft.ApiManagement/service/users/generateSsoUrl/action",
      "Microsoft.ApiManagement/service/users/token/action",
      "Microsoft.ApiManagement/service/products/write",
      "Microsoft.ApiManagement/service/products/delete",
      "Microsoft.ApiManagement/service/products/apis/write",
      "Microsoft.ApiManagement/service/products/apis/delete",
      "Microsoft.ApiManagement/service/products/policies/write",
      "Microsoft.ApiManagement/service/products/policies/delete",
      "Microsoft.ApiManagement/service/products/groups/write",
      "Microsoft.ApiManagement/service/products/groups/delete",
      "Microsoft.ApiManagement/service/products/tags/write",
      "Microsoft.ApiManagement/service/products/tags/delete",
      "Microsoft.ApiManagement/service/subscriptions/write",
      "Microsoft.ApiManagement/service/subscriptions/delete",
      "Microsoft.ApiManagement/service/subscriptions/regeneratePrimaryKey/action",
      "Microsoft.ApiManagement/service/subscriptions/regenerateSecondaryKey/action",
      "Microsoft.ApiManagement/service/apis/write",
      "Microsoft.ApiManagement/service/apis/delete",
      "Microsoft.ApiManagement/service/apis/operations/write",
      "Microsoft.ApiManagement/service/apis/operations/delete",
      "Microsoft.ApiManagement/service/apis/operations/policies/write",
      "Microsoft.ApiManagement/service/apis/operations/policies/delete",
      "Microsoft.ApiManagement/service/apis/operations/tags/write",
      "Microsoft.ApiManagement/service/apis/operations/tags/delete",
      "Microsoft.ApiManagement/service/apis/revisions/delete",
      "Microsoft.ApiManagement/service/apis/releases/delete",
      "Microsoft.ApiManagement/service/apis/releases/write",
      "Microsoft.ApiManagement/service/apis/policies/write",
      "Microsoft.ApiManagement/service/apis/policies/delete",
      "Microsoft.ApiManagement/service/apis/schemas/write",
      "Microsoft.ApiManagement/service/apis/schemas/delete",
      "Microsoft.ApiManagement/service/apis/issues/write",
      "Microsoft.ApiManagement/service/apis/issues/delete",
      "Microsoft.ApiManagement/service/apis/issues/attachments/write",
      "Microsoft.ApiManagement/service/apis/issues/attachments/delete",
      "Microsoft.ApiManagement/service/apis/issues/comments/write",
      "Microsoft.ApiManagement/service/apis/issues/comments/delete",
      "Microsoft.ApiManagement/service/apis/tagDescriptions/write",
      "Microsoft.ApiManagement/service/apis/tagDescriptions/delete",
      "Microsoft.ApiManagement/service/apis/tags/write",
      "Microsoft.ApiManagement/service/apis/tags/delete",
      "Microsoft.ApiManagement/service/apis/diagnostics/write",
      "Microsoft.ApiManagement/service/apis/diagnostics/delete",
      "Microsoft.ApiManagement/service/policies/write",
      "Microsoft.ApiManagement/service/policies/delete",
      "Microsoft.ApiManagement/service/certificates/write",
      "Microsoft.ApiManagement/service/certificates/delete",
      "Microsoft.ApiManagement/service/loggers/write",
      "Microsoft.ApiManagement/service/loggers/delete",
      "Microsoft.ApiManagement/service/authorizationServers/write",
      "Microsoft.ApiManagement/service/authorizationServers/delete",
      "Microsoft.ApiManagement/service/backends/write",
      "Microsoft.ApiManagement/service/backends/delete",
      "Microsoft.ApiManagement/service/backends/reconnect/action",
      "Microsoft.ApiManagement/service/templates/write",
      "Microsoft.ApiManagement/service/templates/delete",
      "Microsoft.ApiManagement/service/properties/write",
      "Microsoft.ApiManagement/service/properties/delete",
      "Microsoft.ApiManagement/service/notifications/write",
      "Microsoft.ApiManagement/service/notifications/recipientEmails/write",
      "Microsoft.ApiManagement/service/notifications/recipientEmails/delete",
      "Microsoft.ApiManagement/service/notifications/recipientUsers/write",
      "Microsoft.ApiManagement/service/notifications/recipientUsers/delete",
      "Microsoft.ApiManagement/service/openidConnectProviders/write",
      "Microsoft.ApiManagement/service/openidConnectProviders/delete",
      "Microsoft.ApiManagement/service/quotas/write",
      "Microsoft.ApiManagement/service/quotas/periods/write",
      "Microsoft.ApiManagement/service/identityProviders/write",
      "Microsoft.ApiManagement/service/identityProviders/delete",
      "Microsoft.ApiManagement/service/portalsettings/write",
      "Microsoft.ApiManagement/service/diagnostics/write",
      "Microsoft.ApiManagement/service/diagnostics/delete",
      "Microsoft.ApiManagement/service/tags/write",
      "Microsoft.ApiManagement/service/tags/delete",
      "Microsoft.ApiManagement/service/users/confirmations/send/action",
      "Microsoft.ApiManagement/service/apiVersionSets/write",
      "Microsoft.ApiManagement/service/apiVersionSets/delete",
      "Microsoft.ApiManagement/service/contentTypes/contentItems/write",
      "Microsoft.ApiManagement/service/contentTypes/contentItems/delete",
      "Microsoft.ApiManagement/service/caches/write",
      "Microsoft.ApiManagement/service/caches/delete",
      "Microsoft.ApiManagement/service/policy/write",
      "Microsoft.ApiManagement/service/policy/delete",
      "Microsoft.ApiManagement/service/apis/policy/write",
      "Microsoft.ApiManagement/service/apis/policy/delete",
      "Microsoft.ApiManagement/service/apis/operations/policy/write",
      "Microsoft.ApiManagement/service/apis/operations/policy/delete",
      "Microsoft.ApiManagement/service/products/policy/write",
      "Microsoft.ApiManagement/service/products/policy/delete",
      "Microsoft.ApiManagement/service/gateways/write",
      "Microsoft.ApiManagement/service/gateways/delete",
      "Microsoft.ApiManagement/service/gateways/keys/action",
      "Microsoft.ApiManagement/service/gateways/regeneratePrimaryKey/action",
      "Microsoft.ApiManagement/service/gateways/regenerateSecondaryKey/action",
      "Microsoft.ApiManagement/service/gateways/token/action",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "api_management_noaccess_definition" {
  name              = "api-management-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.ApiManagement/register/action",
      "Microsoft.ApiManagement/unregister/action",
      "Microsoft.ApiManagement/service/write",
      "Microsoft.ApiManagement/service/read",
      "Microsoft.ApiManagement/service/delete",
      "Microsoft.ApiManagement/service/updatehostname/action",
      "Microsoft.ApiManagement/service/updatecertificate/action",
      "Microsoft.ApiManagement/service/backup/action",
      "Microsoft.ApiManagement/service/restore/action",
      "Microsoft.ApiManagement/service/managedeployments/action",
      "Microsoft.ApiManagement/service/getssotoken/action",
      "Microsoft.ApiManagement/service/applynetworkconfigurationupdates/action",
      "Microsoft.ApiManagement/service/users/action",
      "Microsoft.ApiManagement/service/notifications/action",
      "Microsoft.ApiManagement/service/gateways/action",
      "Microsoft.ApiManagement/service/operationresults/read",
      "Microsoft.ApiManagement/operations/read",
      "Microsoft.ApiManagement/checkNameAvailability/read",
      "Microsoft.ApiManagement/service/networkstatus/read",
      "Microsoft.ApiManagement/service/locations/networkstatus/read",
      "Microsoft.ApiManagement/reports/read",
      "Microsoft.ApiManagement/service/tenant/read",
      "Microsoft.ApiManagement/service/tenant/write",
      "Microsoft.ApiManagement/service/tenant/delete",
      "Microsoft.ApiManagement/service/tenant/regeneratePrimaryKey/action",
      "Microsoft.ApiManagement/service/tenant/regenerateSecondaryKey/action",
      "Microsoft.ApiManagement/service/tenant/deploy/action",
      "Microsoft.ApiManagement/service/tenant/save/action",
      "Microsoft.ApiManagement/service/tenant/validate/action",
      "Microsoft.ApiManagement/service/tenant/operationResults/read",
      "Microsoft.ApiManagement/service/tenant/syncState/read",
      "Microsoft.ApiManagement/service/groups/read",
      "Microsoft.ApiManagement/service/groups/write",
      "Microsoft.ApiManagement/service/groups/delete",
      "Microsoft.ApiManagement/service/groups/users/read",
      "Microsoft.ApiManagement/service/groups/users/write",
      "Microsoft.ApiManagement/service/groups/users/delete",
      "Microsoft.ApiManagement/service/users/read",
      "Microsoft.ApiManagement/service/users/write",
      "Microsoft.ApiManagement/service/users/delete",
      "Microsoft.ApiManagement/service/users/generateSsoUrl/action",
      "Microsoft.ApiManagement/service/users/token/action",
      "Microsoft.ApiManagement/service/users/groups/read",
      "Microsoft.ApiManagement/service/users/subscriptions/read",
      "Microsoft.ApiManagement/service/products/read",
      "Microsoft.ApiManagement/service/products/write",
      "Microsoft.ApiManagement/service/products/delete",
      "Microsoft.ApiManagement/service/products/apis/read",
      "Microsoft.ApiManagement/service/products/apis/write",
      "Microsoft.ApiManagement/service/products/apis/delete",
      "Microsoft.ApiManagement/service/products/subscriptions/read",
      "Microsoft.ApiManagement/service/products/policies/read",
      "Microsoft.ApiManagement/service/products/policies/write",
      "Microsoft.ApiManagement/service/products/policies/delete",
      "Microsoft.ApiManagement/service/products/groups/read",
      "Microsoft.ApiManagement/service/products/groups/write",
      "Microsoft.ApiManagement/service/products/groups/delete",
      "Microsoft.ApiManagement/service/products/tags/read",
      "Microsoft.ApiManagement/service/products/tags/write",
      "Microsoft.ApiManagement/service/products/tags/delete",
      "Microsoft.ApiManagement/service/subscriptions/read",
      "Microsoft.ApiManagement/service/subscriptions/write",
      "Microsoft.ApiManagement/service/subscriptions/delete",
      "Microsoft.ApiManagement/service/subscriptions/regeneratePrimaryKey/action",
      "Microsoft.ApiManagement/service/subscriptions/regenerateSecondaryKey/action",
      "Microsoft.ApiManagement/service/apis/read",
      "Microsoft.ApiManagement/service/apis/write",
      "Microsoft.ApiManagement/service/apis/delete",
      "Microsoft.ApiManagement/service/apis/operations/read",
      "Microsoft.ApiManagement/service/apis/operations/write",
      "Microsoft.ApiManagement/service/apis/operations/delete",
      "Microsoft.ApiManagement/service/apis/operations/policies/read",
      "Microsoft.ApiManagement/service/apis/operations/policies/write",
      "Microsoft.ApiManagement/service/apis/operations/policies/delete",
      "Microsoft.ApiManagement/service/apis/operations/tags/read",
      "Microsoft.ApiManagement/service/apis/operations/tags/write",
      "Microsoft.ApiManagement/service/apis/operations/tags/delete",
      "Microsoft.ApiManagement/service/apis/revisions/read",
      "Microsoft.ApiManagement/service/apis/revisions/delete",
      "Microsoft.ApiManagement/service/apis/releases/read",
      "Microsoft.ApiManagement/service/apis/releases/delete",
      "Microsoft.ApiManagement/service/apis/releases/write",
      "Microsoft.ApiManagement/service/apis/policies/read",
      "Microsoft.ApiManagement/service/apis/policies/write",
      "Microsoft.ApiManagement/service/apis/policies/delete",
      "Microsoft.ApiManagement/service/apis/products/read",
      "Microsoft.ApiManagement/service/apis/schemas/read",
      "Microsoft.ApiManagement/service/apis/schemas/write",
      "Microsoft.ApiManagement/service/apis/schemas/delete",
      "Microsoft.ApiManagement/service/apis/issues/read",
      "Microsoft.ApiManagement/service/apis/issues/write",
      "Microsoft.ApiManagement/service/apis/issues/delete",
      "Microsoft.ApiManagement/service/apis/issues/attachments/read",
      "Microsoft.ApiManagement/service/apis/issues/attachments/write",
      "Microsoft.ApiManagement/service/apis/issues/attachments/delete",
      "Microsoft.ApiManagement/service/apis/issues/comments/read",
      "Microsoft.ApiManagement/service/apis/issues/comments/write",
      "Microsoft.ApiManagement/service/apis/issues/comments/delete",
      "Microsoft.ApiManagement/service/apis/tagDescriptions/read",
      "Microsoft.ApiManagement/service/apis/tagDescriptions/write",
      "Microsoft.ApiManagement/service/apis/tagDescriptions/delete",
      "Microsoft.ApiManagement/service/apis/tags/read",
      "Microsoft.ApiManagement/service/apis/tags/write",
      "Microsoft.ApiManagement/service/apis/tags/delete",
      "Microsoft.ApiManagement/service/apis/operationsByTags/read",
      "Microsoft.ApiManagement/service/apis/diagnostics/read",
      "Microsoft.ApiManagement/service/apis/diagnostics/write",
      "Microsoft.ApiManagement/service/apis/diagnostics/delete",
      "Microsoft.ApiManagement/service/policies/read",
      "Microsoft.ApiManagement/service/policies/write",
      "Microsoft.ApiManagement/service/policies/delete",
      "Microsoft.ApiManagement/service/reports/read",
      "Microsoft.ApiManagement/service/policySnippets/read",
      "Microsoft.ApiManagement/service/certificates/read",
      "Microsoft.ApiManagement/service/certificates/write",
      "Microsoft.ApiManagement/service/certificates/delete",
      "Microsoft.ApiManagement/service/loggers/read",
      "Microsoft.ApiManagement/service/loggers/write",
      "Microsoft.ApiManagement/service/loggers/delete",
      "Microsoft.ApiManagement/service/authorizationServers/read",
      "Microsoft.ApiManagement/service/authorizationServers/write",
      "Microsoft.ApiManagement/service/authorizationServers/delete",
      "Microsoft.ApiManagement/service/backends/read",
      "Microsoft.ApiManagement/service/backends/write",
      "Microsoft.ApiManagement/service/backends/delete",
      "Microsoft.ApiManagement/service/backends/reconnect/action",
      "Microsoft.ApiManagement/service/templates/read",
      "Microsoft.ApiManagement/service/templates/write",
      "Microsoft.ApiManagement/service/templates/delete",
      "Microsoft.ApiManagement/service/properties/read",
      "Microsoft.ApiManagement/service/properties/write",
      "Microsoft.ApiManagement/service/properties/delete",
      "Microsoft.ApiManagement/service/notifications/read",
      "Microsoft.ApiManagement/service/notifications/write",
      "Microsoft.ApiManagement/service/notifications/recipientEmails/read",
      "Microsoft.ApiManagement/service/notifications/recipientEmails/write",
      "Microsoft.ApiManagement/service/notifications/recipientEmails/delete",
      "Microsoft.ApiManagement/service/notifications/recipientUsers/read",
      "Microsoft.ApiManagement/service/notifications/recipientUsers/write",
      "Microsoft.ApiManagement/service/notifications/recipientUsers/delete",
      "Microsoft.ApiManagement/service/openidConnectProviders/read",
      "Microsoft.ApiManagement/service/openidConnectProviders/write",
      "Microsoft.ApiManagement/service/openidConnectProviders/delete",
      "Microsoft.ApiManagement/service/quotas/read",
      "Microsoft.ApiManagement/service/quotas/write",
      "Microsoft.ApiManagement/service/quotas/periods/read",
      "Microsoft.ApiManagement/service/quotas/periods/write",
      "Microsoft.ApiManagement/service/identityProviders/read",
      "Microsoft.ApiManagement/service/identityProviders/write",
      "Microsoft.ApiManagement/service/identityProviders/delete",
      "Microsoft.ApiManagement/service/portalsettings/read",
      "Microsoft.ApiManagement/service/portalsettings/write",
      "Microsoft.ApiManagement/service/diagnostics/read",
      "Microsoft.ApiManagement/service/diagnostics/write",
      "Microsoft.ApiManagement/service/diagnostics/delete",
      "Microsoft.ApiManagement/service/tags/read",
      "Microsoft.ApiManagement/service/tags/write",
      "Microsoft.ApiManagement/service/tags/delete",
      "Microsoft.ApiManagement/service/tagResources/read",
      "Microsoft.ApiManagement/service/apisByTags/read",
      "Microsoft.ApiManagement/service/productsByTags/read",
      "Microsoft.ApiManagement/service/users/confirmations/send/action",
      "Microsoft.ApiManagement/service/apiVersionSets/read",
      "Microsoft.ApiManagement/service/apiVersionSets/write",
      "Microsoft.ApiManagement/service/apiVersionSets/delete",
      "Microsoft.ApiManagement/service/apiVersionSets/versions/read",
      "Microsoft.ApiManagement/service/contentTypes/read",
      "Microsoft.ApiManagement/service/contentTypes/contentItems/read",
      "Microsoft.ApiManagement/service/contentTypes/contentItems/write",
      "Microsoft.ApiManagement/service/contentTypes/contentItems/delete",
      "Microsoft.ApiManagement/service/users/identities/read",
      "Microsoft.ApiManagement/service/regions/read",
      "Microsoft.ApiManagement/service/issues/read",
      "Microsoft.ApiManagement/service/caches/read",
      "Microsoft.ApiManagement/service/caches/write",
      "Microsoft.ApiManagement/service/caches/delete",
      "Microsoft.ApiManagement/service/users/keys/read",
      "Microsoft.ApiManagement/service/policy/read",
      "Microsoft.ApiManagement/service/policy/write",
      "Microsoft.ApiManagement/service/policy/delete",
      "Microsoft.ApiManagement/service/apis/policy/read",
      "Microsoft.ApiManagement/service/apis/policy/write",
      "Microsoft.ApiManagement/service/apis/policy/delete",
      "Microsoft.ApiManagement/service/apis/operations/policy/read",
      "Microsoft.ApiManagement/service/apis/operations/policy/write",
      "Microsoft.ApiManagement/service/apis/operations/policy/delete",
      "Microsoft.ApiManagement/service/products/policy/read",
      "Microsoft.ApiManagement/service/products/policy/write",
      "Microsoft.ApiManagement/service/products/policy/delete",
      "Microsoft.ApiManagement/service/gateways/read",
      "Microsoft.ApiManagement/service/gateways/write",
      "Microsoft.ApiManagement/service/gateways/delete",
      "Microsoft.ApiManagement/service/gateways/keys/action",
      "Microsoft.ApiManagement/service/gateways/regeneratePrimaryKey/action",
      "Microsoft.ApiManagement/service/gateways/regenerateSecondaryKey/action",
      "Microsoft.ApiManagement/service/gateways/token/action",
    ]
  }
}
